%
% $Id: heart-state.pl,v 1.1 2009-05-07 22:18:53 gjn Exp $
%
%     Copyright 2004-9 by Grzegorz J. Nalepa and A. Ligeza
%
%     HeaRT the main shell
%
%
%     Copyright (C) 2004-6 by G. J. Nalepa, A. Ligeza
%     Copyright (C) 2009   by S. Bobek, M. Gawedzki
%     Copyright (C) 2006-9 by the HeKatE Project
%
%     HeaRT has been develped by the HeKatE Project, 
%     see http://hekate.ia.agh.edu.pl
%
%     This file is part of HeaRT.
%
%     HeaRT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
%
%     HeaRT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
%
%     You should have received a copy of the GNU General Public License
%     along with HeaRT.  If not, see <http://www.gnu.org/licenses/>.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
:- write('HeaRT: $Id: heart-state.pl,v 1.1 2009-05-07 22:18:53 gjn Exp $'),nl.

state_copy(From,To) :-
	retractall(xstat To:_),
	state_copy_helper(From,To).

state_copy_helper(From,To):-
	xstat From: Val,
	assert(xstat To: Val),
	fail.
state_copy_helper(_,_).

state_print(State) :-
	xstat State:_,
	write('State \"'), write(State), write('\": '),nl,
	state_print_helper(State),
	!.
state_print_helper(State):-
	xstat State:Val,
	write(Val),write(','),
	fail.
state_print_helper(_):-nl.
